<?php

namespace App\Http\Controllers;

use App\Http\Controllers\ResponseController;
use App\Http\Controllers\EncryptionController;
use App\Http\Controllers\ResourcesController;
use Illuminate\Http\Request;
use Illuminate\Support\Carbon;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage;
use Illuminate\Http\File;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use App\Http\Controllers\FunctionsController;
use Dompdf\Dompdf;

class OrderReceptionController extends Controller
{
    private $responseController;
    private $encController;
    private $resourcesController;
    private $functionsController;
    private $documentManagementController;

    public function __construct(){
        $this->responseController = new ResponseController();
        $this->encController = new EncryptionController();
        $this->resourcesController = new ResourcesController();
        $this->functionsController = new FunctionsController();
        $this->documentManagementController = new DocumentManagementController();
    }

    public function getOrderReception($user, $line) {
        DB::beginTransaction();
        try {
            $getOrderReception = DB::table('S002V01TORCO')
                ->where('ORCO_NULI', '=', $line)
                ->where('DESP_NULI', '=', $line)
                ->where('DESP_ESTA', '=', 'Activo')
                ->where('ORCO_ESTA', '=', 'Recibido')
                ->orWhere('ORCO_ESTA', '=', 'Facturado')
                ->orWhere('ORCO_ESTA', '=', 'Devuelto')
                ->join('S002V01TDESP','DESP_IDDE','=','ORCO_IDDE')
                ->join('S002V01TLINE','LINE_IDLI','=','ORCO_IDLI')
                ->get([
                    'ORCO_NUOR',
                    'ORCO_ESTA',
                    'ORCO_INEX',
                    'ORCO_USRE',
                    'ORCO_FERE',
                    'ORCO_USMO',
                    'ORCO_FEMO',
                    'ORCO_FEAR',
                    'LINE_IDLI',
                    'LINE_NUPR',
                    'LINE_OTPR',
                    'LINE_OTCO',
                    'DESP_IDDE',
                    'DESP_NODE',
                    'DESP_NOMB',
                    'DESP_APPA',
                    'DESP_APMA',
                    'DESP_LADA',
                    'DESP_TELE',
                    'DESP_CORR',
                    'DESP_CALL',
                    'DESP_NUEX',
                    'DESP_NUIN',
                    'DESP_COPO',
                    'DESP_COLO',
                    'DESP_LOCA',
                    'DESP_MUNI',
                    'DESP_ENTI',
                    'DESP_PAIS',
                    'DESP_COME',
                    'DESP_ESTA',
                    'DESP_INEX',
                    'DESP_USRE',
                    'DESP_FERE',
                    'DESP_USMO',
                    'DESP_FEMO',
                    'DESP_FEAR',
                ]);
        } catch (\Throwable $th) {
            DB::rollBack();
            return $this->responseController->makeResponse(true, "ERR_ORDER_RECEPTION_GET000: Ocurrió un error al obtener los datos.", $th->getMessage(), 500);
        }
        DB::commit();
        return $this->responseController->makeResponse(false, "ÉXITO: Consulta Exitosa", $getOrderReception);
    }

    public function getListArtitleReception($orderNumber, $user, $line) {
        $arrResponseCheckUser = $this->resourcesController->checkUserEnc($user, $line);
        if ($arrResponseCheckUser['error']) {
            return $this->responseController->makeResponse(true, 'ERR_RECEPTION_GET001:'.$arrResponseCheckUser['msg'], [], 401);
        }

        try {
            $orderNumber = $this->encController->decrypt($orderNumber);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(true, "ERR_RECEPTION_GET002: Ocurrió un error el número de la orden de compra.", $th->getMessage(), 500);
        }

        
        try {
            $arrOrder = (array) DB::table('S002V01TORCO')
                ->where('ORCO_NUOR', '=', $orderNumber)
                ->where('ORCO_NULI', '=', $line)
                ->where('ORCO_ESTA', '=', 'Recibido')
                ->orWhere('ORCO_ESTA', '=', 'Facturado')
                ->first([
                    'ORCO_IDDE',
                    'ORCO_IDLI',
                ]);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(true, "ERR_RECEPTION_GET003: Ocurrió un error al obtener los datos de la orden de compra.", $th->getMessage(), 500);
        }
        if (empty($arrOrder)) {
            return $this->responseController->makeResponse(true, "ERR_RECEPTION_GET004: No se pudo encontrar la información de la orden de compra. ", [], 500);
        }


        try {
            $arrListOrder = DB::table('S002V01TARSE')
                ->where('ARSE_IDLI', '=', $arrOrder['ORCO_IDLI'])
                ->where('ARSE_ESTA', '=', 'Activo')
                ->where('ARTI_ESTA', '=', 'Activo')
                ->where('FAMI_ESTA', '=', 'Activo')
                ->where('SUBF_ESTA', '=', 'Activo')
                ->where('DEAR_ESTA', '=', 'Activo')
                ->where('INAR_ESTA', '=', 'Activo')
                ->where('UNID_ESTA', '=', 'Activo')
                ->where('ARSE_NULI', '=', $line)
                ->where('ARTI_NULI', '=', $line)
                ->where('FAMI_NULI', '=', $line)
                ->where('SUBF_NULI', '=', $line)
                ->where('DEAR_NULI', '=', $line)
                ->where('INAR_NULI', '=', $line)
                ->where('UNID_NULI', '=', $line)
                ->join('S002V01TARTI','ARTI_IDAR','=','ARSE_IDAR')
                ->join('S002V01TFAMI','ARTI_COFA','=','FAMI_COFA')
                ->join('S002V01TSUBF','ARTI_COSU','=','SUBF_COSU')
                ->join('S002V01TINAR','INAR_IDIN','=','ARSE_IDIN')
                ->join('S002V01TDEAR','DEAR_IDDE','=','INAR_IDDE')
                ->join('S002V01TUNID','UNID_IDUN','=','DEAR_IDUN')
                ->get([
                    'FAMI_COFA AS CODIGO_FAMILIA',
                    'FAMI_NOFA AS NOMBRE_FAMILIA',
                    'SUBF_COSU AS CODIGO_SUBFAMILIA',
                    'SUBF_NOSU AS NOMBRE_SUBFAMILIA',
                    'ARTI_IDAR AS ID_ARTICULO',
                    'ARTI_CODI AS CODIGO_ARTICULO',
                    'ARTI_NOMB AS NOMBRE_ARTICULO',
                    'DEAR_IDDE AS ID_DESCRIPCION',
                    'DEAR_IMAG AS IMAGENES',
                    'DEAR_DESC AS DESCRIPCION',
                    'DEAR_CARA AS CARACTERISTICAS',
                    'DEAR_COWE AS COMPRA_WEB',
                    'INAR_IDIN AS ID_INFORMACION',
                    'INAR_CODI AS CODIGO_INFORMACION',
                    'INAR_MODE AS MODELO_INFORMACION',
                    'INAR_COMO AS CODIGO_MONEDA',
                    'INAR_PREC AS PRECIO_UNITARIO',
                    'INAR_MOMI AS MONTO_MINIMO',
                    'INAR_CARA AS CARACTERISTICAS_INFORMACION',
                ]);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(true, "ERR_RECEPTION_GET005: Ocurrió un error al obtener los datos de los artículos", $th->getMessage(), 500);
        }

        
        try {
            foreach ($arrListOrder as $listOrder) {
                $arrImagen = json_decode($listOrder->IMAGENES);
                $arrUrlImage = array();
                foreach ($arrImagen as $key => $imagen) {
                    $arrResponse = $this->documentManagementController->privateGetPublicDocumentURL($imagen, $user, $line);
                    if ($arrResponse['error']) {
                        return $this->responseController->makeResponse(true, "ERR_RECEPTION_GET006: Ocurrió un error al obtener la URL de la imágen.", $arrResponse['msg'], 500);
                    }
                    $arrUrlImage[] = $arrResponse['response']['public_uri'];
                }
                $listOrder->IMAGENES = $arrUrlImage;
            }
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_RECEPTION_GET007: Ocurrió un error al obtener las imangenes de los artículos 1.", 
                $th->getMessage(), 
                500
            );
        }

        return $this->responseController->makeResponse(false, "ÉXITO: Consulta Exitosa", $arrListOrder);
    }

    public function getInformartionArtitleToEquipment($orderNumber, $idInformation, $user, $line) {
        try {
            $orderNumber = $this->encController->decrypt($orderNumber);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(true, "ERR_INFORMATION_GET000: Ocurrió un error al obtener el número de orden de compra.", $th->getMessage(), 500);
        }
        try {
            $idInformation = $this->encController->decrypt($idInformation);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(true, "ERR_INFORMATION_GET001: Ocurrió un error al obtener el número de información.", $th->getMessage(), 500);
        }

        $arrResponseCheckUser = $this->resourcesController->checkUserEnc($user, $line);
        if ($arrResponseCheckUser['error']) {
            return $this->responseController->makeResponse(true, 'ERR_INFORMATION_GET002:'.$arrResponseCheckUser['msg'], [], 401);
        }

        try {
            $arrOrder = (array) DB::table('S002V01TORCO')
                ->where('ORCO_NUOR', '=', $orderNumber)
                ->where('ORCO_NULI', '=', $line)
                ->where('ORCO_ESTA', '=', 'Recibido')
                ->first([
                    'ORCO_IDDE AS ID_DESPACHO',
                    'ORCO_IDLI AS ID_LINEA_SOLICITUD',
                ]);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(true, "ERR_INFORMATION_GET003: Ocurrió un error al obtener los datos de la orden de compra.", $th->getMessage(), 500);
        }
        if (empty($arrOrder)) {
            return $this->responseController->makeResponse(true, "ERR_INFORMATION_GET004: El número de orden no existe o no se encuentra entregado.", [], 500);
        }

        try {
            $arrHistoryOrder = DB::table('S002V01THIOR')
                ->where('HIOR_NUOR', '=', $orderNumber)
                ->where('HIOR_ESTA', '=', 'Activo')
                ->where('HIOR_ESOR', '=', 'Recibido')
                ->get([
                    'HIOR_FERE AS FECHA_REGISTRA',
                    'HIOR_FEMO AS FECHA_MODIFICA',
                ]);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(true, "ERR_INFORMATION_GET005: Ocurrió un error al obtener los del historial.", $th->getMessage(), 500);
        }
        $arrHistoryOrder = json_decode(json_encode($arrHistoryOrder), true);
        if (empty($arrHistoryOrder)) {
            return $this->responseController->makeResponse(true, "ERR_INFORMATION_GET006: No se pudo encontrar la información del historial.", [], 500);
        }

        $dateAdquisition = null;
        foreach ($arrHistoryOrder as $key => $historyOrder) {
            $tempDateAdquisition = $historyOrder['FECHA_MODIFICA'] !== null ? $historyOrder['FECHA_MODIFICA'] : $historyOrder['FECHA_REGISTRA'];
            if (is_null($dateAdquisition)) {
                $dateAdquisition = $tempDateAdquisition;
            } else {
                $carDateAdquisition = new Carbon($dateAdquisition);
                $carTempDateAdquisition = new Carbon($tempDateAdquisition);
                if ($carTempDateAdquisition->greaterThan($carDateAdquisition)) {
                    $dateAdquisition = $tempDateAdquisition;
                }
            }
        }

        if (is_null($dateAdquisition)) {
            return $this->responseController->makeResponse(true, "ERR_INFORMATION_GET007: Ocurrió un error al obtener la fecha de adquisición.", [], 500);
        }
        
        try {
            $arrListOrder = (array) DB::table('S002V01TARSE')
                ->where('ARSE_IDLI', '=', $arrOrder['ID_LINEA_SOLICITUD'])
                ->where('ARSE_IDIN', '=', $idInformation)
                ->where('ARSE_ESTA', '=', 'Activo')
                ->where('ARTI_ESTA', '=', 'Activo')
                ->where('FAMI_ESTA', '=', 'Activo')
                ->where('SUBF_ESTA', '=', 'Activo')
                ->where('DEAR_ESTA', '=', 'Activo')
                ->where('INAR_ESTA', '=', 'Activo')
                ->where('UNID_ESTA', '=', 'Activo')
                ->where('ARSE_NULI', '=', $line)
                ->where('ARTI_NULI', '=', $line)
                ->where('FAMI_NULI', '=', $line)
                ->where('SUBF_NULI', '=', $line)
                ->where('DEAR_NULI', '=', $line)
                ->where('INAR_NULI', '=', $line)
                ->where('UNID_NULI', '=', $line)
                ->join('S002V01TARTI','ARTI_IDAR','=','ARSE_IDAR')
                ->join('S002V01TFAMI','ARTI_COFA','=','FAMI_COFA')
                ->join('S002V01TSUBF','ARTI_COSU','=','SUBF_COSU')
                ->join('S002V01TINAR','INAR_IDIN','=','ARSE_IDIN')
                ->join('S002V01TDEAR','DEAR_IDDE','=','INAR_IDDE')
                ->join('S002V01TUNID','UNID_IDUN','=','DEAR_IDUN')
                ->join('S002V01TPROV','PROV_NUPR','=','ARSE_NUPR')
                ->first([
                    'FAMI_COFA AS CODIGO_FAMILIA',
                    'FAMI_NOFA AS NOMBRE_FAMILIA',
                    'SUBF_COSU AS CODIGO_SUBFAMILIA',
                    'SUBF_NOSU AS NOMBRE_SUBFAMILIA',
                    'ARTI_IDAR AS ID_ARTICULO',
                    'ARTI_CODI AS CODIGO_ARTICULO',
                    'ARTI_NOMB AS NOMBRE_ARTICULO',
                    'DEAR_IDDE AS ID_DESCRIPCION',
                    'DEAR_IMAG AS IMAGENES',
                    'DEAR_DESC AS DESCRIPCION',
                    'DEAR_CARA AS CARACTERISTICAS',
                    'DEAR_COWE AS COMPRA_WEB',
                    'INAR_IDIN AS ID_INFORMACION',
                    'INAR_CODI AS CODIGO_INFORMACION',
                    'INAR_MODE AS MODELO_INFORMACION',
                    'INAR_COMO AS CODIGO_MONEDA',
                    'INAR_PREC AS PRECIO_UNITARIO',
                    'INAR_MOMI AS MONTO_MINIMO',
                    'INAR_CARA AS CARACTERISTICAS_INFORMACION',
                    'PROV_NUPR AS NUMERO_PROVEEDOR',
                    'PROV_NOCO AS NOMBRE_PROVEEDOR',
                ]);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(true, "ERR_INFORMATION_GET008: Ocurrió un error al obtener los datos de los artículos", $th->getMessage(), 500);
        }
        if (empty($arrListOrder)) {
            return $this->responseController->makeResponse(true, "ERR_INFORMATION_GET009: No existen artículos regitrados en la orden de compra.", [], 500);
        }

        try {
            $arrImagen = json_decode($arrListOrder['IMAGENES']);
            $arrUrlImage = array();
            foreach ($arrImagen as $key => $imagen) {
                $arrResponse = $this->documentManagementController->privateGetPublicDocumentURL($imagen, $user, $line);
                if($arrResponse['error']){
                    return $this->responseController->makeResponse(true, "ERR_RECEPTION_GET006: Ocurrió un error al obtener la URL de la imágen.", $arrResponse['msg'], 500);
                }
                $arrUrlImage[] = $arrResponse['response']['public_uri'];
            }
            $arrListOrder['IMAGENES'] = $arrUrlImage;
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_RECEPTION_GET007: Ocurrió un error al obtener las imangenes de los artículos.", 
                $th->getMessage(), 
                500
            );
        }

        $arrListOrder['FECHA_ADQUISICION'] = $dateAdquisition;
        $arrListOrder['ID_LINEA_SOLICITUD'] = $arrOrder['ID_LINEA_SOLICITUD'];

        return $this->responseController->makeResponse(false, "ÉXITO: Consulta Exitosa", $arrListOrder);
    }

    public function generateSheetDeliveryListXLS( $orderNumber, $user, $line ) {
        try {
            $idOrder = $this->encController->decrypt($orderNumber);
        } catch (\Throwable $th) {
            DB::rollBack();
            return $this->responseController->makeResponse(
                true, 
                "ERR_ORDER_SHEET000: Ocurrió un error al obtener el número del proveedor.", 
                $th->getMessage(), 
                500
            );
        }

        try {
            $user = $this->encController->decrypt($user);
        } catch (\Throwable $th) {
            DB::rollBack();
            return $this->responseController->makeResponse(
                true, 
                "ERR_ORDER_SHEET001: Ocurrió un error al obtener el usuario.", 
                $th->getMessage(), 
                500
            );
        }

        try {
            $arrOrder = (array) DB::table('S002V01TORCO')
                ->where('ORCO_NUOR', '=', $idOrder)
                ->where('ORCO_NULI', '=', $line)
                ->where('LINE_NULI', '=', $line)
                ->where('DESP_NULI', '=', $line)
                ->where('PROV_NULI', '=', $line)
                ->where('DESP_ESTA', '=', 'Activo')
                ->where('PROV_ESTA', '=', 'Activo')
                ->join('S002V01TLINE', 'LINE_IDLI', '=', 'ORCO_IDLI')
                ->join('S002V01TDESP', 'DESP_IDDE', '=', 'ORCO_IDDE')
                ->join('S002V01TPROV', 'PROV_NUPR', '=', 'LINE_NUPR')
                ->join('S002V01TREFI', 'REFI_CRFI', '=', 'PROV_CRFI')
                ->first([
                    'ORCO_NUOR',
                    'ORCO_ESTA',
                    'LINE_IDLI',
                    'LINE_OTPR',
                    'LINE_OTCO',
                    'LINE_ESTA',
                    'DESP_IDDE',
                    'DESP_NODE',
                    'DESP_NOMB',
                    'DESP_APPA',
                    'DESP_APMA',
                    'DESP_LADA',
                    'DESP_TELE',
                    'DESP_CORR',
                    'DESP_CALL',
                    'DESP_NUEX',
                    'DESP_NUIN',
                    'DESP_COPO',
                    'DESP_COLO',
                    'DESP_LOCA',
                    'DESP_MUNI',
                    'DESP_ENTI',
                    'DESP_PAIS',
                    'DESP_COME',
                    'PROV_NUPR',
                    'PROV_IDPS',
                    'PROV_NOCO',
                    'PROV_NOMB',
                    'PROV_APPA',
                    'PROV_APMA',
                    'PROV_CORR',
                    'PROV_LAD1',
                    'PROV_TEL1',
                    'PROV_LAD2',
                    'PROV_TEL2',
                    'PROV_XRFC',
                    'PROV_XTAX',
                    'PROV_TIPO',
                    'PROV_TICO',
                    'PROV_SIWE',
                    'PROV_MEPA',
                    'PROV_CALL',
                    'PROV_NUEX',
                    'PROV_NUIN',
                    'PROV_COPO',
                    'PROV_COLO',
                    'PROV_MUNI',
                    'PROV_LOCA',
                    'PROV_ENTI',
                    'PROV_PAIS',
                    'REFI_CRFI',
                    'REFI_DRFI',
                ]);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_ORDER_SHEET002: Ocurrió un error al obtener la información de la orden de compra.", 
                $th->getMessage(), 
                500
            );
        }


        try {
            $arrArtitle = DB::table('S002V01TARSE')
                ->where('ARSE_NULI', '=', $line)
                ->where('INAR_NULI', '=', $line)
                ->where('CAMO_NULI', '=', $line)
                ->where('DEAR_NULI', '=', $line)
                ->where('UNID_NULI', '=', $line)
                ->where('ARTI_NULI', '=', $line)
                ->where('FAMI_NULI', '=', $line)
                ->where('SUBF_NULI', '=', $line)
                ->where('ARSE_ESTA', '=', 'Activo')
                ->where('INAR_ESTA', '=', 'Activo')
                ->where('CAMO_ESTA', '=', 'Activo')
                ->where('DEAR_ESTA', '=', 'Activo')
                ->where('UNID_ESTA', '=', 'Activo')
                ->where('ARTI_ESTA', '=', 'Activo')
                ->where('FAMI_ESTA', '=', 'Activo')
                ->where('SUBF_ESTA', '=', 'Activo')
                ->where('ARSE_IDLI', '=', $arrOrder['LINE_IDLI'])
                ->where('ARSE_NUPR', '=', $arrOrder['PROV_NUPR'])
                ->join('S002V01TINAR','INAR_IDIN','=','ARSE_IDIN')
                ->join('S002V01TCAMO','CAMO_COMO','=','INAR_COMO')
                ->join('S002V01TDEAR','DEAR_IDDE','=','INAR_IDDE')
                ->join('S002V01TUNID','UNID_IDUN','=','DEAR_IDUN')
                ->join('S002V01TARTI','ARTI_IDAR','=','DEAR_IDAR')
                ->join('S002V01TFAMI','FAMI_COFA','=','ARTI_COFA')
                ->join('S002V01TSUBF','SUBF_COSU','=','ARTI_COSU')
                ->get([
                    'ARSE_IDAS',
                    'ARSE_IDLI',
                    // 'ARSE_CANT',
                    // 'ARSE_PRTO',
                    'INAR_IDIN',
                    'INAR_CODI',
                    'INAR_MODE',
                    'INAR_PREC',
                    'INAR_MOMI',
                    'INAR_CARA',
                    'CAMO_COMO',
                    'CAMO_DESC',
                    'CAMO_DECI',
                    'CAMO_POVA',
                    'CAMO_FEIN',
                    'CAMO_FEFI',
                    'DEAR_IDDE',
                    'DEAR_IMAG',
                    'DEAR_DESC',
                    'DEAR_CARA',
                    'DEAR_COWE',
                    'UNID_IDUN',
                    'UNID_NOMB',
                    'UNID_ACRO',
                    'ARTI_IDAR',
                    'ARTI_CODI',
                    'ARTI_NOMB',
                    'FAMI_COFA',
                    'FAMI_NOFA',
                    'SUBF_COSU',
                    'SUBF_NOSU',
                ]);
            $arrArtitle = json_decode( json_encode( $arrArtitle ), true );
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_ORDER_SHEET002: Ocurrió un error al obtener la información de la orden de compra.", 
                $th->getMessage(), 
                500
            );
        }

        $index = 0;
        $arrArtitlesTemp = array();
        foreach ($arrArtitle as $keyArtitle => $artitles) {
            if ($keyArtitle === 0) {
                $arrArtitlesTemp[$index] = $artitles;
                $arrArtitlesTemp[$index]['CANTIDAD'] = 1;
            } else {
                if (
                    in_array($artitles['INAR_IDIN'], array_column($arrArtitlesTemp, 'INAR_IDIN'))
                ) {
                    $indexArtitle = array_search($artitles['INAR_IDIN'], array_column($arrArtitlesTemp, 'INAR_IDIN'));
                    $arrArtitlesTemp[$indexArtitle]['CANTIDAD'] = $arrArtitlesTemp[$indexArtitle]['CANTIDAD'] + 1;
                } else {
                    $index = $index + 1;
                    $arrArtitlesTemp[$index] = $artitles;
                    $arrArtitlesTemp[$index]['CANTIDAD'] = 1;
                }
            }
        }
        $arrArtitle = $arrArtitlesTemp;
        

        $spreadsheet = new Spreadsheet();
        $activeWorksheet = $spreadsheet->getActiveSheet()->setTitle($arrOrder['ORCO_NUOR']);


        $headerA1 = 'Número de orden';
        $contentB1 = $arrOrder['ORCO_NUOR'];
        $activeWorksheet->setCellValue("A1", $headerA1);
        $activeWorksheet->setCellValue("B1", $contentB1);
        $activeWorksheet->getStyle( "A1" )->getFont()->setBold(true);


        $headerA2 = 'Estado de la orden';
        $contentB2 = $arrOrder['ORCO_ESTA'];
        $activeWorksheet->setCellValue("A2", $headerA2);
        $activeWorksheet->setCellValue("B2", $contentB2);
        $activeWorksheet->getStyle( "A2" )->getFont()->setBold(true);


        $headerA3 = 'Numero de línea de solicitud';
        $contentB3 = $arrOrder['LINE_IDLI'];
        $activeWorksheet->setCellValue("A3", $headerA3);
        $activeWorksheet->setCellValue("B3", $contentB3);
        $activeWorksheet->getStyle( "A3" )->getFont()->setBold(true);


        $headerA4 = '';
        if ( !is_null( $arrOrder['LINE_OTPR'] ) && is_null( $arrOrder['LINE_OTCO'] )  ) {
            $headerA4 = 'Orden de Trabajo Preventivo';
            $contentB4 = $arrOrder['LINE_OTPR'];
        } else if ( is_null( $arrOrder['LINE_OTPR'] ) && !is_null( $arrOrder['LINE_OTCO'] )  ) {
            $headerA4 = 'Orden de Trabajo Correctivo';
            $contentB4 = $arrOrder['LINE_OTCO'];
        } else if ( is_null( $arrOrder['LINE_OTPR'] ) && is_null( $arrOrder['LINE_OTCO'] )  ) {
            $headerA4 = 'Orden de Trabajo';
            $contentB4 = 'No aplica';
        } else {
            $headerA4 = 'Orden de Trabajo';
            $contentB4 = 'No aplica';
        }
        $activeWorksheet->setCellValue("A4", $headerA4 );
        $activeWorksheet->setCellValue("B4", $contentB4 );
        $activeWorksheet->getStyle( "A4" )->getFont()->setBold(true);


        $headerA5 = 'ID Despacho';
        $contentB5 = $arrOrder['DESP_IDDE'];
        $activeWorksheet->setCellValue("A5", $headerA5 );
        $activeWorksheet->setCellValue("B5", $contentB5 );
        $activeWorksheet->getStyle( "A5" )->getFont()->setBold(true);


        $headerA6 = 'Despacho';
        $contentB6 = $arrOrder['DESP_NODE'];
        $activeWorksheet->setCellValue("A6", $headerA6 );
        $activeWorksheet->setCellValue("B6", $contentB6 );
        $activeWorksheet->getStyle( "A6" )->getFont()->setBold(true);


        $headerA7 = 'Responsable del despacho';
        $contentB7 = $arrOrder['DESP_NOMB'] . ' ' . $arrOrder['DESP_APPA'] . ' ' . $arrOrder['DESP_APMA'];
        $activeWorksheet->setCellValue("A7", $headerA7 );
        $activeWorksheet->setCellValue("B7", $contentB7 );
        $activeWorksheet->getStyle( "A7" )->getFont()->setBold(true);


        $headerA8 = 'Teléfono del despacho';
        $contentB8 = $arrOrder['DESP_LADA'] . ' ' . $arrOrder['DESP_TELE'];
        $activeWorksheet->setCellValue("A8", $headerA8 );
        $activeWorksheet->setCellValue("B8", $contentB8 );
        $activeWorksheet->getStyle( "A8" )->getFont()->setBold(true);


        $headerA9 = 'Correo electrónico del despacho';
        $contentB9 = $arrOrder['DESP_CORR'];
        $activeWorksheet->setCellValue("A9", $headerA9 );
        $activeWorksheet->setCellValue("B9", $contentB9 );
        $activeWorksheet->getStyle( "A9" )->getFont()->setBold(true);


        $headerA10 = 'Calle del despacho';
        $contentB10 = $arrOrder['DESP_CALL'];
        $activeWorksheet->setCellValue("A10", $headerA10 );
        $activeWorksheet->setCellValue("B10", $contentB10 );
        $activeWorksheet->getStyle( "A10" )->getFont()->setBold(true);

        
        $headerA11 = 'Número exterior';
        $contentB11 = $arrOrder['DESP_NUEX'];
        $activeWorksheet->setCellValue("A11", $headerA11 );
        $activeWorksheet->setCellValue("B11", $contentB11 );
        $activeWorksheet->getStyle( "A11" )->getFont()->setBold(true);


        $headerA12 = 'Número interior';
        if ( !is_null($arrOrder['DESP_NUIN']) ) {
            $contentB12 = $arrOrder['DESP_NUIN'];
        } else {
            $contentB12 = 'No aplica';
        }
        $activeWorksheet->setCellValue("A12", $headerA12 );
        $activeWorksheet->setCellValue("B12", $contentB12 );
        $activeWorksheet->getStyle( "A12" )->getFont()->setBold(true);


        $headerA13 = 'Código postal';
        $contentB13 = $arrOrder['DESP_COPO'];
        $activeWorksheet->setCellValue("A13", $headerA13 );
        $activeWorksheet->setCellValue("B13", $contentB13 );
        $activeWorksheet->getStyle( "A13" )->getFont()->setBold(true);

        
        $headerA14 = 'Colonia';
        $contentB14 = $arrOrder['DESP_COLO'];
        $activeWorksheet->setCellValue("A14", $headerA14 );
        $activeWorksheet->setCellValue("B14", $contentB14 );
        $activeWorksheet->getStyle( "A14" )->getFont()->setBold(true);


        $headerA15 = 'Localidad';
        if ( !is_null($arrOrder['DESP_LOCA']) && !empty($arrOrder['DESP_LOCA']) ) {
            $contentB15 = $arrOrder['DESP_LOCA'];
        } else {
            $contentB15 = 'No aplica';
        }
        $activeWorksheet->setCellValue("A15", $headerA15 );
        $activeWorksheet->setCellValue("B15", $contentB15 );
        $activeWorksheet->getStyle( "A15" )->getFont()->setBold(true);


        $headerA16 = 'Municipio';
        $contentB16 = $arrOrder['DESP_MUNI'];
        $activeWorksheet->setCellValue("A16", $headerA16 );
        $activeWorksheet->setCellValue("B16", $contentB16 );
        $activeWorksheet->getStyle( "A16" )->getFont()->setBold(true);


        $headerA17 = 'Entidad Federativa';
        $contentB17 = $arrOrder['DESP_ENTI'];
        $activeWorksheet->setCellValue("A17", $headerA17 );
        $activeWorksheet->setCellValue("B17", $contentB17 );
        $activeWorksheet->getStyle( "A17" )->getFont()->setBold(true);


        $headerA18 = 'País';
        $contentB18 = $arrOrder['DESP_PAIS'];
        $activeWorksheet->setCellValue("A18", $headerA18 );
        $activeWorksheet->setCellValue("B18", $contentB18 );
        $activeWorksheet->getStyle( "A18" )->getFont()->setBold(true);


        $headerA19 = 'Número de proveedor';
        $contentB19 = $arrOrder['PROV_NUPR'];
        $activeWorksheet->setCellValue("A19", $headerA19 );
        $activeWorksheet->setCellValue("B19", $contentB19 );
        $activeWorksheet->getStyle( "A19" )->getFont()->setBold(true);


        $headerA20 = 'Número de subcontratista';
        $contentB20 = $arrOrder['PROV_IDPS'];
        $activeWorksheet->setCellValue("A20", $headerA20 );
        $activeWorksheet->setCellValue("B20", $contentB20 );
        $activeWorksheet->getStyle( "A20" )->getFont()->setBold(true);


        $headerA21 = 'Nombre comercial del proveedor';
        $contentB21 = $arrOrder['PROV_NOCO'];
        $activeWorksheet->setCellValue("A21", $headerA21 );
        $activeWorksheet->setCellValue("B21", $contentB21 );
        $activeWorksheet->getStyle( "A21" )->getFont()->setBold(true);


        $headerA22 = 'Referencia fiscal del proveedor';
        $contentB22 = $arrOrder['REFI_DRFI'] . ' (' . $arrOrder['REFI_CRFI'] . ')';
        $activeWorksheet->setCellValue("A22", $headerA22 );
        $activeWorksheet->setCellValue("B22", $contentB22 );
        $activeWorksheet->getStyle( "A22" )->getFont()->setBold(true);


        $headerA23 = 'Responsable del proveedor';
        $contentB23 = $arrOrder['PROV_NOMB'] . ' ' . $arrOrder['PROV_APPA'] . ' ' . $arrOrder['PROV_APMA'];
        $activeWorksheet->setCellValue("A23", $headerA23 );
        $activeWorksheet->setCellValue("B23", $contentB23 );
        $activeWorksheet->getStyle( "A23" )->getFont()->setBold(true);


        $headerA24 = 'Correo electrónico del proveedor';
        $contentB24 = $arrOrder['PROV_CORR'];
        $activeWorksheet->setCellValue("A24", $headerA24 );
        $activeWorksheet->setCellValue("B24", $contentB24 );
        $activeWorksheet->getStyle( "A24" )->getFont()->setBold(true);


        $headerA25 = 'Teléfono del proveedor';
        $contentB25 = $arrOrder['PROV_LAD1'] . ' ' . $arrOrder['PROV_TEL1'];
        $activeWorksheet->setCellValue("A25", $headerA25 );
        $activeWorksheet->setCellValue("B25", $contentB25 );
        $activeWorksheet->getStyle( "A25" )->getFont()->setBold(true);


        $headerA26 = '';
        $contentB26 = '';
        if ( !is_null( $arrOrder['PROV_XRFC'] ) && is_null( $arrOrder['PROV_XRFC'] )) {
            $headerA26 = 'R.F.C. del proveedor';
            $contentB26 = $arrOrder['PROV_XRFC'];
        } else if ( is_null( $arrOrder['PROV_XRFC'] ) && !is_null( $arrOrder['PROV_XRFC'] )) {
            $headerA26 = 'TAX ID. del proveedor';
            $contentB26 = $arrOrder['PROV_XTAX'];
        } else {
            $headerA26 = 'R.F.C. / TAX ID';
            $contentB26 = 'No aplica';
        }
        $activeWorksheet->setCellValue("A26", $headerA26 );
        $activeWorksheet->setCellValue("B26", $contentB26 );
        $activeWorksheet->getStyle( "A26" )->getFont()->setBold(true);

        
        $activeWorksheet->getColumnDimension("A")->setAutoSize(true);
        $activeWorksheet->getColumnDimension("B")->setAutoSize(true);


        $arrAlphabet = $this->resourcesController->arrAlphabet;


        $spreadsheet->createSheet();
        $spreadsheet->setActiveSheetIndex(1);
        $activeWorksheetArtitle = $spreadsheet->getActiveSheet()->setTitle('Artículos de la orden');
        $arrHeaderArtitle = array(
            /* A */ 'ID Artículo',
            /* B */ 'Código del Artíulo',
            /* C */ 'Artículo',
            /* D */ 'Familia',
            /* E */ 'Subfamilia',
            /* F */ 'Descripción',
            /* G */ 'Características',
            /* H */ 'Unidad',
            /* I */ 'Código',
            /* J */ 'Modelo',
            /* L */ 'Precio Unitario',
            /* M */ 'Cantidad',
            /* N */ 'Precio Total',
            /* O */ 'No. de selección',
        );
        foreach ($arrArtitle as $key => $artitle) {
            $key = $key + 2;

            $activeWorksheetArtitle->setCellValue("A".$key, $artitle['ARTI_IDAR']);
            $activeWorksheetArtitle->setCellValue("B".$key, $artitle['ARTI_CODI']);
            $activeWorksheetArtitle->setCellValue("C".$key, $artitle['ARTI_NOMB']);
            $activeWorksheetArtitle->setCellValue("D".$key, $artitle['FAMI_NOFA'] . ' (' . $artitle['FAMI_COFA'] . ')');
            $activeWorksheetArtitle->setCellValue("E".$key, $artitle['SUBF_NOSU'] . ' (' . $artitle['SUBF_COSU'] . ')');
            $activeWorksheetArtitle->setCellValue("F".$key, $artitle['DEAR_DESC']);
            $activeWorksheetArtitle->setCellValue("G".$key, $artitle['DEAR_CARA']);
            $activeWorksheetArtitle->setCellValue("H".$key, $artitle['UNID_NOMB'] . ' (' . $artitle['UNID_IDUN'] . ')');
            $activeWorksheetArtitle->setCellValue("I".$key, $artitle['INAR_CODI']);
            $activeWorksheetArtitle->setCellValue("J".$key, $artitle['INAR_MODE']);
            $activeWorksheetArtitle->setCellValue("K".$key, '$'. $artitle['INAR_PREC'] . ' ' . $artitle['CAMO_COMO'] );
            $activeWorksheetArtitle->setCellValue("L".$key, $artitle['CANTIDAD']);
            $activeWorksheetArtitle->setCellValue("M".$key, '$'. ($artitle['INAR_PREC'] * $artitle['CANTIDAD']) . ' ' . $artitle['CAMO_COMO'] );
            $activeWorksheetArtitle->setCellValue("N".$key, $artitle['ARSE_IDAS']);
        }
        foreach ($arrHeaderArtitle as $keyHeaderArtitle => $headerArtitle) {
            $activeWorksheetArtitle->setCellValue( $arrAlphabet[$keyHeaderArtitle]."1", $headerArtitle);
            $activeWorksheetArtitle->getColumnDimension( $arrAlphabet[$keyHeaderArtitle] )->setAutoSize(true);
            $activeWorksheetArtitle->getStyle( $arrAlphabet[$keyHeaderArtitle]."1" )->getFont()->setBold(true);
        }

        $nuli = $this->resourcesController->formatSecuence($line, 2);
        $como = 'GEAD';         // Código del módulo
        $cldo = 'IN';           // Código de la clasificación
        $fecr = date('ymd');    // Fecha en la se carga el archivo

        try {
            $arrSecuence = (array) DB::table('S002V01TAFAL')
                ->where('AFAL_COMO', '=', $como)
                ->where('AFAL_CLDO', '=', $cldo)
                ->where('AFAL_NULI', '=', $line)
                ->orderBy('AFAL_NUSE', 'desc')
                ->first([ 'AFAL_NUSE' ]);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_PROVIDER_SHEET020: Ocurrió un error al obtener la información de la secuencia.", 
                $th->getMessage(), 
                500
            );
        }
        $nuse = 1;              // Secuencia del documento
        if ( !empty( $arrSecuence ) && !is_null( $arrSecuence ) ) {
            $nuse = intval( $arrSecuence['AFAL_NUSE'] ) + 1; 
        }
        $nuse = $this->resourcesController->formatSecuence($nuse, 6);
        $nuve = $this->resourcesController->formatSecuence('1', 2);
        $noar = 'ficha_de_adquisición_' . $arrOrder['ORCO_NUOR'];
        $exte = 'xlsx';

        if ($_SERVER['SERVER_NAME'] === '192.168.100.105') {
            $filePath = 'C:/ITTEC/SAM/Dev/SistemaMantenimiento/sistema-mantenimiento-back/public/public_files/';    // API JEAN
        } else {
            $filePath = 'C:\inetpub\wwwroot\sam\public_files\\';     // API QA
        }

        $fileName = $nuli.'-'.$como.'-'.$cldo.'-'.$fecr.'-'.$nuse.'='.$nuve.'='.$noar.'.'.$exte;

        $tempFile = $filePath.$fileName;

        if ( file_exists( $tempFile ) ) {
            if ( !unlink( $tempFile ) ) {
                return $this->responseController->makeResponse(
                    true, 
                    "ERR_PROVIDER_SHEET021: Ocurrió un error al eliminar el siguiente archivo: " . $tempFile, 
                    [], 
                    500
                );
            }
        }
        
        try {
            $writer = new Xlsx($spreadsheet);
            ob_start();
            $writer->save('php://output');
            $base64 = base64_encode(ob_get_clean());
            $validate = \File::put( $tempFile, base64_decode($base64));
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_PROVIDER_SHEET022: Ocurrió un error al guardar el documento.", 
                $th->getMessage(), 
                500
            );
        }


        $ubic = Storage::putFile('files', new File($tempFile));
        $ubic = str_replace("/", "\\", $ubic);
        if ($_SERVER['SERVER_NAME'] === '192.168.100.105') {
            $ubic = "C:\ITTEC\SAM\Dev\SistemaMantenimiento\sistema-mantenimiento-back\storage\app\\" . $ubic;
        } else {
            $ubic = "C:\inetpub\wwwroot\sam\storage\app\\" . $ubic;
        }
        $tama = filesize($ubic);
        $usac = json_encode([$user]);


        $now = $this->functionsController->now();
        $currentDate = $now->toDateTimeString();

        try {
            $validateInsert = DB::table('S002V01TAFAL')->insert([
                'AFAL_NULI' => $line,
                'AFAL_COMO' => $como,
                'AFAL_CLDO' => $cldo,
                'AFAL_FECR' => $fecr,
                'AFAL_NUSE' => $nuse,
                'AFAL_NUVE' => $nuve,
                'AFAL_NOAR' => $noar,
                'AFAL_EXTE' => $exte,
                'AFAL_TAMA' => $tama,
                'AFAL_UBIC' => $ubic,
                'AFAL_USAC' => $usac,
                'AFAL_USRE' => $user,
                'AFAL_FERE' => $currentDate,
            ]);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_PROVIDER_SHEET023: Ocurrió un error guardar los datos a la tabla final de archivos.", 
                $th->getMessage(), 
                500
            );
        }

        if ( !$validateInsert ) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_PROVIDER_SHEET024: No se pudo guardar la ficha del proveedor en la base de datos.", 
                [], 
                500
            );
        }
        
        if ($_SERVER['SERVER_NAME'] === '192.168.100.105') {
            $urlPublic = 'http://192.168.100.105:8000/public_files/' . $fileName;
        } else {
            $urlPublic = $this->functionsController->getApiURI().'sam/public_files/' . $fileName;
        }

        return $this->responseController->makeResponse(false, "EXITO: Modificación Exitosa", [ 'url' => $urlPublic ]);
    }
    public function generateSheetDeliveryListPDF( $orderNumber, $user, $line ) {
        try {
            $idOrder = $this->encController->decrypt($orderNumber);
        } catch (\Throwable $th) {
            DB::rollBack();
            return $this->responseController->makeResponse(
                true, 
                "ERR_ORDER_SHEET000: Ocurrió un error al obtener el número del proveedor.", 
                $th->getMessage(), 
                500
            );
        }

        try {
            $user = $this->encController->decrypt($user);
        } catch (\Throwable $th) {
            DB::rollBack();
            return $this->responseController->makeResponse(
                true, 
                "ERR_ORDER_SHEET001: Ocurrió un error al obtener el usuario.", 
                $th->getMessage(), 
                500
            );
        }

        try {
            $arrOrder = (array) DB::table('S002V01TORCO')
                ->where('ORCO_NUOR', '=', $idOrder)
                ->where('ORCO_NULI', '=', $line)
                ->where('LINE_NULI', '=', $line)
                ->where('DESP_NULI', '=', $line)
                ->where('PROV_NULI', '=', $line)
                ->where('DESP_ESTA', '=', 'Activo')
                ->where('PROV_ESTA', '=', 'Activo')
                ->join('S002V01TLINE', 'LINE_IDLI', '=', 'ORCO_IDLI')
                ->join('S002V01TDESP', 'DESP_IDDE', '=', 'ORCO_IDDE')
                ->join('S002V01TPROV', 'PROV_NUPR', '=', 'LINE_NUPR')
                ->join('S002V01TREFI', 'REFI_CRFI', '=', 'PROV_CRFI')
                ->first([
                    'ORCO_NUOR',
                    'ORCO_ESTA',
                    'LINE_IDLI',
                    'LINE_OTPR',
                    'LINE_OTCO',
                    'LINE_ESTA',
                    'DESP_IDDE',
                    'DESP_NODE',
                    'DESP_NOMB',
                    'DESP_APPA',
                    'DESP_APMA',
                    'DESP_LADA',
                    'DESP_TELE',
                    'DESP_CORR',
                    'DESP_CALL',
                    'DESP_NUEX',
                    'DESP_NUIN',
                    'DESP_COPO',
                    'DESP_COLO',
                    'DESP_LOCA',
                    'DESP_MUNI',
                    'DESP_ENTI',
                    'DESP_PAIS',
                    'DESP_COME',
                    'PROV_NUPR',
                    'PROV_IDPS',
                    'PROV_NOCO',
                    'PROV_NOMB',
                    'PROV_APPA',
                    'PROV_APMA',
                    'PROV_CORR',
                    'PROV_LAD1',
                    'PROV_TEL1',
                    'PROV_LAD2',
                    'PROV_TEL2',
                    'PROV_XRFC',
                    'PROV_XTAX',
                    'PROV_TIPO',
                    'PROV_TICO',
                    'PROV_SIWE',
                    'PROV_MEPA',
                    'PROV_CALL',
                    'PROV_NUEX',
                    'PROV_NUIN',
                    'PROV_COPO',
                    'PROV_COLO',
                    'PROV_MUNI',
                    'PROV_LOCA',
                    'PROV_ENTI',
                    'PROV_PAIS',
                    'REFI_CRFI',
                    'REFI_DRFI',
                ]);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_ORDER_SHEET002: Ocurrió un error al obtener la información de la orden de compra.", 
                $th->getMessage(), 
                500
            );
        }


        try {
            $arrArtitle = DB::table('S002V01TARSE')
                ->where('ARSE_NULI', '=', $line)
                ->where('INAR_NULI', '=', $line)
                ->where('CAMO_NULI', '=', $line)
                ->where('DEAR_NULI', '=', $line)
                ->where('UNID_NULI', '=', $line)
                ->where('ARTI_NULI', '=', $line)
                ->where('FAMI_NULI', '=', $line)
                ->where('SUBF_NULI', '=', $line)
                ->where('ARSE_ESTA', '=', 'Activo')
                ->where('INAR_ESTA', '=', 'Activo')
                ->where('CAMO_ESTA', '=', 'Activo')
                ->where('DEAR_ESTA', '=', 'Activo')
                ->where('UNID_ESTA', '=', 'Activo')
                ->where('ARTI_ESTA', '=', 'Activo')
                ->where('FAMI_ESTA', '=', 'Activo')
                ->where('SUBF_ESTA', '=', 'Activo')
                ->where('ARSE_IDLI', '=', $arrOrder['LINE_IDLI'])
                ->where('ARSE_NUPR', '=', $arrOrder['PROV_NUPR'])
                ->join('S002V01TINAR','INAR_IDIN','=','ARSE_IDIN')
                ->join('S002V01TCAMO','CAMO_COMO','=','INAR_COMO')
                ->join('S002V01TDEAR','DEAR_IDDE','=','INAR_IDDE')
                ->join('S002V01TUNID','UNID_IDUN','=','DEAR_IDUN')
                ->join('S002V01TARTI','ARTI_IDAR','=','DEAR_IDAR')
                ->join('S002V01TFAMI','FAMI_COFA','=','ARTI_COFA')
                ->join('S002V01TSUBF','SUBF_COSU','=','ARTI_COSU')
                ->get([
                    'ARSE_IDAS',
                    'ARSE_IDLI',
                    // 'ARSE_CANT',
                    // 'ARSE_PRTO',
                    'INAR_IDIN',
                    'INAR_CODI',
                    'INAR_MODE',
                    'INAR_PREC',
                    'INAR_MOMI',
                    'INAR_CARA',
                    'CAMO_COMO',
                    'CAMO_DESC',
                    'CAMO_DECI',
                    'CAMO_POVA',
                    'CAMO_FEIN',
                    'CAMO_FEFI',
                    'DEAR_IDDE',
                    'DEAR_IMAG',
                    'DEAR_DESC',
                    'DEAR_CARA',
                    'DEAR_COWE',
                    'UNID_IDUN',
                    'UNID_NOMB',
                    'UNID_ACRO',
                    'ARTI_IDAR',
                    'ARTI_CODI',
                    'ARTI_NOMB',
                    'FAMI_COFA',
                    'FAMI_NOFA',
                    'SUBF_COSU',
                    'SUBF_NOSU',
                ]);
            $arrArtitle = json_decode( json_encode( $arrArtitle ), true );
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_ORDER_SHEET002: Ocurrió un error al obtener la información de la orden de compra.", 
                $th->getMessage(), 
                500
            );
        }

        $index = 0;
        $arrArtitlesTemp = array();
        foreach ($arrArtitle as $keyArtitle => $artitles) {
            if ($keyArtitle === 0) {
                $arrArtitlesTemp[$index] = $artitles;
                $arrArtitlesTemp[$index]['CANTIDAD'] = 1;
            } else {
                if (
                    in_array($artitles['INAR_IDIN'], array_column($arrArtitlesTemp, 'INAR_IDIN'))
                ) {
                    $indexArtitle = array_search($artitles['INAR_IDIN'], array_column($arrArtitlesTemp, 'INAR_IDIN'));
                    $arrArtitlesTemp[$indexArtitle]['CANTIDAD'] = $arrArtitlesTemp[$indexArtitle]['CANTIDAD'] + 1;
                } else {
                    $index = $index + 1;
                    $arrArtitlesTemp[$index] = $artitles;
                    $arrArtitlesTemp[$index]['CANTIDAD'] = 1;
                }
            }
        }
        $arrArtitle = $arrArtitlesTemp;

        $html = '<!DOCTYPE html>
        <html lang="en">
        <head>
            <meta charset="UTF-8">
            <meta name="viewport" content="width=device-width, initial-scale=1.0">
            <title>Document</title>
            <style>
                body {
                    font-family: Arial, Helvetica, sans-serif;
                    font-size: 8pt;
                }
                .section-title { 
                    margin: 20px 0;
                    font-size: 12pt;
                }

                table {
                    width: 100%;
                    font-size: 8pt;
                }

                thead tr th {
                    text-align: start;
                    padding: 0 16px;
                    height: 52px;
                    border-bottom-width: 1px;
                    border-bottom-style: solid;
                    border-bottom-color: #CCC;
                }

                tbody tr td {
                    padding: 0 16px;
                    height: 52px;
                    border-bottom-width: 1px;
                    border-bottom-style: solid;
                    border-bottom-color: #CCC;
                }

                p {
                    text-align: justify;
                }

            </style>
        </head>
        <body>
            <div class="item">
                <b>Número de Orden de Compra: </b>
                <span>'.$arrOrder['ORCO_NUOR'].'</span>
            </div>
            <div class="item">
                <b>Estado de la orden: </b>
                <span>'.$arrOrder['ORCO_ESTA'].'</span>
            </div>
            <div class="item">
                <b>Numero de línea de solicitud: </b>
                <span>'.$arrOrder['LINE_IDLI'].'</span>
            </div>
        ';

        if ( !is_null( $arrOrder['LINE_OTPR'] ) && is_null( $arrOrder['LINE_OTCO'] )  ) {
            $html.='<div class="item">
                        <b>Orden de Trabajo Preventivo: </b>
                        <span>'.$arrOrder['LINE_OTPR'].'</span>
                    </div>';
        } else if ( is_null( $arrOrder['LINE_OTPR'] ) && !is_null( $arrOrder['LINE_OTCO'] )  ) {
            $html.='<div class="item">
                        <b>Orden de Trabajo Correctivo: </b>
                        <span>'.$arrOrder['LINE_OTCO'].'</span>
                    </div>';
        } else if ( is_null( $arrOrder['LINE_OTPR'] ) && is_null( $arrOrder['LINE_OTCO'] )  ) {
            $html.='<div class="item">
                        <b>Orden de Trabajo: </b>
                        <span>No aplica</span>
                    </div>';
        } else {
            $html.='<div class="item">
                        <b>Orden de Trabajo: </b>
                        <span>No aplica</span>
                    </div>';
        }

        $html.='<div class="item">
                    <b>ID Despacho: </b>
                    <span>'.$arrOrder['DESP_IDDE'].'</span>
                </div>
                <div class="item">
                    <b>Despacho: </b>
                    <span>'.$arrOrder['DESP_NODE'].'</span>
                </div>
                <div class="item">
                    <b>Responsable del despacho: </b>
                    <span>'.$arrOrder['DESP_NOMB'] . ' ' . $arrOrder['DESP_APPA'] . ' ' . $arrOrder['DESP_APMA'].'</span>
                </div>
                <div class="item">
                    <b>Teléfono del despacho: </b>
                    <span>'.$arrOrder['DESP_LADA'] . ' ' . $arrOrder['DESP_TELE'].'</span>
                </div>
                <div class="item">
                    <b>Correo electrónico del despacho: </b>
                    <span>'.$arrOrder['DESP_CORR'].'</span>
                </div>
                <div class="item">
                    <b>Calle del despacho: </b>
                    <span>'.$arrOrder['DESP_CALL'].'</span>
                </div>
                <div class="item">
                    <b>Número exterior: </b>
                    <span>'.$arrOrder['DESP_NUEX'].'</span>
                </div>
        ';
        if ( !is_null($arrOrder['DESP_NUIN']) ) {
            $html.='<div class="item">
                        <b>Número interior: </b>
                        <span>'.$arrOrder['DESP_NUIN'].'</span>
                    </div>';
        } else {
            $html.='<div class="item">
                        <b>Número interior: </b>
                        <span>No aplica</span>
                    </div>';
        }

        $html.='<div class="item">
                    <b>Código postal: </b>
                    <span>'.$arrOrder['DESP_COPO'].'</span>
                </div>
                <div class="item">
                    <b>Colonia: </b>
                    <span>'.$arrOrder['DESP_COLO'].'</span>
                </div>
        ';


        if ( !is_null($arrOrder['DESP_LOCA']) && !empty($arrOrder['DESP_LOCA']) ) {
            $html.='<div class="item">
                        <b>Localidad: </b>
                        <span>'.$arrOrder['DESP_LOCA'].'</span>
                    </div>';
        } else {
            $html.='<div class="item">
                        <b>Localidad: </b>
                        <span>No aplica</span>
                    </div>';
        }

        $html.='<div class="item">
                    <b>Municipio: </b>
                    <span>'.$arrOrder['DESP_MUNI'].'</span>
                </div>
                <div class="item">
                    <b>Entidad Federativa: </b>
                    <span>'.$arrOrder['DESP_ENTI'].'</span>
                </div>
                <div class="item">
                    <b>País: </b>
                    <span>'.$arrOrder['DESP_PAIS'].'</span>
                </div>
                <div class="item">
                    <b>Número de proveedor: </b>
                    <span>'.$arrOrder['PROV_NUPR'].'</span>
                </div>
                <div class="item">
                    <b>Número de subcontratista: </b>
                    <span>'.$arrOrder['PROV_IDPS'].'</span>
                </div>
                <div class="item">
                    <b>Nombre comercial del proveedor: </b>
                    <span>'.$arrOrder['PROV_NOCO'].'</span>
                </div>
                <div class="item">
                    <b>Referencia fiscal del proveedor: </b>
                    <span>'.$arrOrder['REFI_DRFI'] . ' (' . $arrOrder['REFI_CRFI'] . ')'.'</span>
                </div>
                <div class="item">
                    <b>Responsable del proveedor: </b>
                    <span>'.$arrOrder['PROV_NOMB'] . ' ' . $arrOrder['PROV_APPA'] . ' ' . $arrOrder['PROV_APMA'].'</span>
                </div>
                <div class="item">
                    <b>Correo electrónico del proveedor: </b>
                    <span>'.$arrOrder['PROV_CORR'].'</span>
                </div>
                <div class="item">
                    <b>Teléfono del proveedor: </b>
                    <span>'.$arrOrder['PROV_LAD1'] . ' ' . $arrOrder['PROV_TEL1'].'</span>
                </div>
        ';

        if ( !is_null( $arrOrder['PROV_XRFC'] ) && is_null( $arrOrder['PROV_XRFC'] )) {
            $html.='<div class="item">
                        <b>R.F.C. del proveedor: </b>
                        <span>'.$arrOrder['PROV_XRFC'].'</span>
                    </div>';
        } else if ( is_null( $arrOrder['PROV_XRFC'] ) && !is_null( $arrOrder['PROV_XRFC'] )) {
            $html.='<div class="item">
                        <b>TAX ID. del proveedor: </b>
                        <span>'.$arrOrder['PROV_XTAX'].'</span>
                    </div>';            
        } else {
            $html.='<div class="item">
                        <b>R.F.C. / TAX ID: </b>
                        <span>No aplica</span>
                    </div>';
        }


        if ( !empty($arrArtitle) ) {
            $html.='
                    <div style="page-break-after:always;"></div>

                    <div class="section-title">
                        <b>Artículos</b>
                    </div>';
            $html.='<table cellspacing="0" cellpadding="0">
                        <thead>
                            <tr>
                                <th>ID Artículo</th>
                                <th>Código del artíulo</th>
                                <th>Artículo</th>
                                <th>Familia</th>
                                <th>Subfamilia</th>
                                <!-- <th>Descripción</th> -->
                                <!-- <th>Características</th> -->
                                <th>Unidad</th>
                                <th>Código</th>
                                <th>Modelo</th>
                                <th>Precio Unitario</th>
                                <th>Cantidad</th>
                                <th>Precio Total</th>
                                <th>No. de selección</th>
                            </tr>
                        </thead>
                        <tbody>';
            foreach ($arrArtitle as $keyArtitle => $artitle) {
                $html.=    '<tr>
                                <td>'.$artitle['ARTI_IDAR'].'</td>
                                <td>'.$artitle['ARTI_CODI'].'</td>
                                <td>'.$artitle['ARTI_NOMB'].'</td>
                                <td>'.$artitle['FAMI_NOFA'] . ' (' . $artitle['FAMI_COFA'] . ')'.'</td>
                                <td>'.$artitle['SUBF_NOSU'] . ' (' . $artitle['SUBF_COSU'] . ')'.'</td>
                                <!-- <td>'.$artitle['DEAR_DESC'].'</td> -->
                                <!-- <td>'.$artitle['DEAR_CARA'].'</td> -->
                                <td>'.$artitle['UNID_NOMB'] . ' (' . $artitle['UNID_IDUN'] . ')'.'</td>
                                <td>'.$artitle['INAR_CODI'].'</td>
                                <td>'.$artitle['INAR_MODE'].'</td>
                                <td>'.'$'. $artitle['INAR_PREC'] . ' ' . $artitle['CAMO_COMO'] .'</td>
                                <td>'.$artitle['CANTIDAD'].'</td>
                                <td>'.'$'. ($artitle['INAR_PREC'] * $artitle['CANTIDAD'] ) . ' ' . $artitle['CAMO_COMO'] .'</td>
                                <td>'.$artitle['ARSE_IDAS'].'</td>
                            </tr>';
            }
            $html.=    '</tbody>
                    </table>';
        }

        $html.='</body></html>';

        $nuli = $this->resourcesController->formatSecuence($line, 2);
        $como = 'GEAD';         // Código del módulo
        $cldo = 'IN';           // Código de la clasificación
        $fecr = date('ymd');    // Fecha en la se carga el archivo

        try {
            $arrSecuence = (array) DB::table('S002V01TAFAL')
                ->where('AFAL_COMO', '=', $como)
                ->where('AFAL_CLDO', '=', $cldo)
                ->where('AFAL_NULI', '=', $line)
                ->orderBy('AFAL_NUSE', 'desc')
                ->first([ 'AFAL_NUSE' ]);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_PROVIDER_SHEET020: Ocurrió un error al obtener la información de la secuencia.", 
                $th->getMessage(), 
                500
            );
        }
        $nuse = 1;              // Secuencia del documento
        if ( !empty( $arrSecuence ) && !is_null( $arrSecuence ) ) {
            $nuse = intval( $arrSecuence['AFAL_NUSE'] ) + 1; 
        }
        $nuse = $this->resourcesController->formatSecuence($nuse, 6);
        $nuve = $this->resourcesController->formatSecuence('1', 2);
        $noar = 'ficha_de_adquisición_' . $arrOrder['ORCO_NUOR'];

        $nuli = $this->resourcesController->formatSecuence($line, 2);
        $como = 'GEAD';         // Código del módulo
        $cldo = 'IN';           // Código de la clasificación
        $fecr = date('ymd');    // Fecha en la se carga el archivo
        try {
            $arrSecuence = (array) DB::table('S002V01TAFAL')
                ->where('AFAL_COMO', '=', $como)
                ->where('AFAL_CLDO', '=', $cldo)
                ->where('AFAL_NULI', '=', $line)
                ->orderBy('AFAL_NUSE', 'desc')
                ->first([ 'AFAL_NUSE' ]);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_PROVIDER_SHEET020: Ocurrió un error al obtener la información de la secuencia.", 
                $th->getMessage(), 
                500
            );
        }
        $nuse = 1;              // Secuencia del documento
        if ( !empty( $arrSecuence ) && !is_null( $arrSecuence ) ) {
            $nuse = intval( $arrSecuence['AFAL_NUSE'] ) + 1; 
        }
        $nuse = $this->resourcesController->formatSecuence($nuse, 6);
        $nuve = $this->resourcesController->formatSecuence('1', 2);
        $noar = 'ficha_de_adquisición_' . $arrOrder['ORCO_NUOR'];
        $exte = 'pdf';        
        
        
        if ($_SERVER['SERVER_NAME'] === '192.168.100.105') {
            $filePath = 'C:/ITTEC/SAM/Dev/SistemaMantenimiento/sistema-mantenimiento-back/public/public_files/';    // API JEAN
        } else {
            $filePath = 'C:\inetpub\wwwroot\sam\public_files\\';     // API QA
        }

        $fileName = $nuli.'-'.$como.'-'.$cldo.'-'.$fecr.'-'.$nuse.'='.$nuve.'='.$noar.'.'.$exte;
        
        $tempFile = $filePath . $fileName;

        $dompdf = new Dompdf();
        $dompdf ->loadHtml($html);
        $dompdf->setPaper('A4', 'landscape');
        $dompdf->render();


        $output = $dompdf->output();
        file_put_contents($tempFile, $output);
        $ubic = Storage::putFile('files', new File($tempFile));

        $ubic = str_replace("/", "\\", $ubic);
        if ($_SERVER['SERVER_NAME'] === '192.168.100.105') {
            $ubic = "C:\ITTEC\SAM\Dev\SistemaMantenimiento\sistema-mantenimiento-back\storage\app\\" . $ubic;
        } else {
            $ubic = "C:\inetpub\wwwroot\sam\storage\app\\" . $ubic;
        }
        $tama = filesize($ubic);
        $usac = json_encode([$user]);

        $now = $this->functionsController->now();
        $currentDate = $now->toDateTimeString();

        try {
            $validateInsert = DB::table('S002V01TAFAL')->insert([
                'AFAL_NULI' => $line,
                'AFAL_COMO' => $como,
                'AFAL_CLDO' => $cldo,
                'AFAL_FECR' => $fecr,
                'AFAL_NUSE' => $nuse,
                'AFAL_NUVE' => $nuve,
                'AFAL_NOAR' => $noar,
                'AFAL_EXTE' => $exte,
                'AFAL_TAMA' => $tama,
                'AFAL_UBIC' => $ubic,
                'AFAL_USAC' => $usac,
                'AFAL_USRE' => $user,
                'AFAL_FERE' => $currentDate,
            ]);
        } catch (\Throwable $th) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_PROVIDER_SHEET023: Ocurrió un error guardar los datos a la tabla final de archivos.", 
                $th->getMessage(), 
                500
            );
        }

        if ( !$validateInsert ) {
            return $this->responseController->makeResponse(
                true, 
                "ERR_PROVIDER_SHEET024: No se pudo guardar la ficha del proveedor en la base de datos.", 
                [], 
                500
            );
        }

        if ($_SERVER['SERVER_NAME'] === '192.168.100.105') {
            $urlPublic = 'http://192.168.100.105:8000/public_files/' . $fileName;
        } else {
            $urlPublic = $this->functionsController->getApiURI().'sam/public_files/' . $fileName;
        }

        return $this->responseController->makeResponse(false, "EXITO: Modificación Exitosa", [ 'url' => $urlPublic ]);
    }
}
